import es, playerlib, gamethread, random, usermsg, os.path

# The only optiosn that are in here are dictionary options that I'm too lazy to make for server vars but will be eventually
### Dict Options ###
messages = {
	0: 'Noob Level!',
	1: '1',
	2: '2',
	3: '3',
	4: '4',
	5: 'Boss Level!',
	6: 'You Win!'
}

ammo = {
	'ammo_338mag_max': 666,
	'ammo_357sig_max': 666,
	'ammo_45acp_max': 666,
	'ammo_50AE_max': 666,
	'ammo_556mm_box_max': 666,
	'ammo_556mm_max': 666,
	'ammo_57mm_max': 666,
	'ammo_762mm_max': 666,
	'ammo_9mm_max': 666,
	'ammo_buckshot_max': 666
}
#### No Config Below ###

### Addon Info ###

info = es.AddonInfo() 
info['name']        = "Zombie Hell 2.0" 
info['version']     = "2.6" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/zombiehell2" 
info['description'] = "A python version of ZombieHell requested by Undead for better speed + performance" 

es.ServerVar('zh2_version', info['version'], 'ZombieHell 2.0 made by Bonbon AKA Bonbon367').makepublic()

### Server Vars ### 

sv = es.ServerVar

sv_options = {
	'zh_zombie_health_min': 200,
	'zh_zombie_health_max': 300,
	'zh_zombie_health_level_bonus_multiplier': 3,
	'zh_zombie_speed_min': 0.8,
	'zh_zombie_speed_max': 1.2,
	'zh_zombie_speed_level_bonus_multiplier': 0.01,
	'zh_zombie_armor_min': 50,
	'zh_zombie_armor_max': 100,
	'zh_zombie_armor_level_bonus_multiplier': 2,
	'zh_zombie_knockback_min': 5,
	'zh_zombie_knockback_max': 10,
	'zh_zombie_knockback_level_multiplier_minus': 1,
	'zh_boss_chance': 10,
	'zh_boss_model': 'humans/corpse1',
	'zh_boss_health_min': 1000,
	'zh_boss_health_max': 3333,
	'zh_boss_speed_min': 1,
	'zh_boss_speed_max': 1.75,
	'zh_boss_armor_min': 1000,
	'zh_boss_armor_max': 3333,
	'zh_boss_knockback_max': 6,
	'zh_boss_knockback_min': 3,
	'zh_boss_sound': 0,
	'zh_fog': 1,
	'zh_fog_rgb': '100,100,100',
	'zh_fog_rgb2': '150,150,150',
	'zh_zombie_models': 'zombie/classic,zombie/fast,zombie/poison,humans/charple01,humans/charple02,humans/charple03,humans/charple04',
	'zh_restricted_weapons': 'm249,g3sg1,sg550,awp,flashbang,smokegrenade',
	'zh_dissolve_on_death': 1,
	'zh_stock_zombies': 3,
	'zh_stock_multiplier': 3,
	'zh_rounds_to_win': 5,
	'zh_hud_update_time': 7,
	'zh_start_cash': 16000,
	'zh_bots': 10,
	'zh_enable_knockback': 1,
	'zh_fog_start': 200,
	'zh_fog_end': 600,
	'zh_ambiance': 0,
	'zh_ambiance_delay': 0,
	'zh_round_end_overlay_win': 0,
	'zh_round_end_overlay_lose': 0,
	'zh_round_start_overlay': 0,
	'zh_overlay_sound': 0,
	'zh_stock_add': 1,
	'zh_dead_talk': 1,
	'zh_zspawn': 1,
	'zh_excluded_dead_characters': '!@/',
	'zh_zombie_gravity_min': 0.8,
	'zh_zombie_gravity_max': 1.2,
	'zh_zombie_gravity_level_multiplier': 0.05,
	'zh_boss_gravity_min': 0.75,
	'zh_boss_gravity_max': 1,
	'zh_zombie_spawn_protection_time': 5,
	'zh_machine_gun_ammo': 100,
	'zh_headshot_only': 0,
	'zh_zombie_regen_delay': 5,
	'zh_zombie_level_regen_multiplier': 0.1,
	'zh_zombie_regen_min': 1,
	'zh_zombie_regen_max': 3,
	'zh_beacon_last_zombie': 1,
	'zh_napalm': 0,
	'zh_napalm_time': 3,
	'zh_health_kill_bonus': 3
}

### Globals ###

zspawn = {}
fogged = 0
temp_zombies = 0
wins = 0
checked = 0

### Loads ###
def load():
	add_downloads()
	zh_fog_start()
	for type in ammo:
		es.server.queuecmd('%s %s'%(type, ammo[type]))
	knife_bot()
	add_bots()
	for a in sv_options:
		es.ServerVar(a).set(sv_options[a])
	if os.path.isfile(es.getAddonPath('zombiehell') + '/zombiehell.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/zombiehell/zombiehell.cfg')
	else:
		es.dbgmsg(0, 'Config not found')
	if not str(sv('zh_ambiance')) == '0':
		ambiance_loop()
	if not es.exists('saycommand', '!zspawn'):
		es.regsaycmd('!zspawn', 'zombiehell/do_zspawn')

def unload():
	if es.getuserid():
		es.server.queuecmd('es_xfire %s env_fog_controller kill'%es.getuserid())
	for loop in ['update_hud', 'ambiance_loop', 'heal_loop', 'beacon_loop']:
		gamethread.cancelDelayed(loop)
	kick_bots()
	if es.exists('saycommand', '!zspawn'):
		es.unregsaycmd('!zspawn')
	es.addons.unregisterClientCommandFilter(zh_buy_filter)

#### Events ###

def player_spawn(ev):
	userid = ev['userid']
	Player(userid).set_attributes(1)
	Player(userid).check_team()
	Player(userid).stop_spawn()
	Player(userid).start_spawn_protection()
	zh_fog_start()

def player_death(ev):
	userid = ev['userid']
	if int(sv('zh_dissolve_on_death')):
		Player(userid).dissolve()
	Player(userid).check_respawn()
	Player(userid).play_sound()
	Player(userid).stop_spawn_protection()
	Player(ev['attacker']).heal()

def es_map_start(ev):
	global wins, fogged, check
	wins, fogged, check = 0, 0, 0
	zh_fog_start()
	add_downloads()
	knife_bot()
	es.server.queuecmd('es_xmexec ../addons/eventscripts/zombiehell/zombiehell.cfg')

def item_pickup(ev):
	Player(ev['userid']).check_restrict(ev['item'])
	if ev['item'] == 'c4': es.server.queuecmd('es_xfire %s weapon_c4 kill'%ev['userid'])

def player_hurt(ev):
	Player(ev['attacker']).check_restrict(ev['weapon'])
	Player(ev['userid']).knockback(ev['attacker'], int(ev['dmg_health']))
	if not random.randint(0, 7):
		Player(ev['userid']).play_sound()
	if int(sv('zh_headshot_only')):
		if not int(ev['hitgroup']) == 1 and not ev['weapon'] in ['weapon_knife', 'weapon_hegrenade']:
			playerlib.getPlayer(ev['userid']).set('health', playerlib.getPlayer(ev['userid']) + int(ev['dmg_health']))
	if ev['weapon'] == 'weapon_hegrenade':
		Player(ev['userid']).napalm()

def round_start(ev):
	global temp_zombies, check
	temp_zombies = len(playerlib.getUseridList('#human')) * int(sv('zh_stock_zombies')) + int(wins * float(sv('zh_stock_multiplier'))) + int(sv('zh_stock_add'))
	for userid in es.getUseridList():
		Player(userid).overlay(1)
	if wins == int(sv('zh_rounds_to_win')) and not str(sv('zh_boss_sound')) == '0':
		for userid in es.getUseridList():
			es.cexec(userid, 'play %s'%str(sv('zh_boss_sound')))
	knife_bot()
	if check:
		add_bots()
	check += 1
	if es.getuserid():
		es.server.queuecmd('es_xfire %s hostage_entity kill'%es.getuserid())

def round_freeze_end(ev):
	if 0 < wins < int(sv('zh_rounds_to_win')):
		es.msg('#multi', '#lightgreenWARNING: #defaultQuarantine level #lightgreen%s#default has been breeched! KILL ON SIGHT!'%wins)
	elif wins == int(sv('zh_rounds_to_win')):
		for userid in es.getUseridList():
			usermsg.shake(userid, 50, 4.5)
		es.msg('#multi', '#lightgreenWARNING: #defaultQuarantine level #lightgreen%s#default has been breeched! ZOMBIES HAVE EVOLVED!'%wins)
	elif wins > int(sv('zh_rounds_to_win')):
		if es.getuserid():
			es.msg('#multi', '#defaultCongratulations on defeating all the zombies, The game will end in #lightgreen5#default seconds')
			gamethread.delayed(5, es.server.queuecmd, 'es_entcreate %s game_end;es_fire %s game_end endgame'%(es.getuserid(), es.getuserid()))

def round_end(ev):
	global wins
	if len(playerlib.getUseridList('#human')) > 0:
		wins = max(0, wins + (1 if not len(playerlib.getUseridList('#bot,#alive')) else -1))
		if wins > int(sv('zh_rounds_to_win')):
			es.msg('#multi', '#defaultCongratulations on defeating all the zombies, The game will end in #lightgreen5#default seconds')
			gamethread.delayed(5, es.server.queuecmd, 'es_entcreate %s game_end;es_fire %s game_end endgame'%(es.getuserid(), es.getuserid()))
		for userid in es.getUseridList():
			Player(userid).overlay(2 if not len(playerlib.getUseridList('#bot,#alive')) else 3)
	else:
		es.msg('Not enough players to start')

def player_team(ev):
	Player(ev['userid']).check_team()

def player_activate(ev):
	Player(ev['userid']).start_spawn()

def player_disconnect(ev):
	Player(ev['userid']).stop_spawn()

def player_say(ev):
	text = ev['text']
	userid = ev['userid']
	if playerlib.getPlayer(ev['userid']).get('isdead') and int(sv('zh_dead_talk')) and not ev['text'][0] in str(sv('zh_excluded_dead_characters')):
		message = '\1*DEAD* \3%s \1: %s'%(es.getplayername(ev['userid']), ev['text'])
		index = playerlib.getPlayer(userid).attributes['index']
		for alive_players in playerlib.getUseridList('#alive'):
			usermsg.saytext2(alive_players, index, message)

### Classes ###

class Player:
	def __init__(self, userid):
		self.userid = userid
		self.steamid = es.getplayersteamid(userid)

	def dissolve(self):
		if not playerlib.getPlayer(self.userid).get('isdead'):
			playerlib.getPlayer(self.userid).set('health', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%self.userid)
		es.server.queuecmd('es_give %s env_entity_dissolver'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "magnitude 1"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "dissolvetype %s"'%(self.userid, random.randint(0, 3)))
		es.server.queuecmd('es_xfire %s env_entity_dissolver Dissolve'%self.userid)
		gamethread.delayed(1, es.server.queuecmd, 'es_xfire %s env_entity_dissolver kill'%self.userid)

	def check_restrict(self, weapon):
		if self.steamid == 'BOT' and not 'knife' in weapon:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%self.userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip StripWeaponsAndSuit'%self.userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%self.userid)
		elif weapon.replace('weapon_', '') in str(sv('zh_restricted_weapons')):
			for index in es.createentitylist('weapon_%s'%weapon.replace('weapon_', '')):
				if int(es.getplayerhandle(self.userid)) == int(es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")):
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(self.userid, '#multi', '#greenSorry, the #lightgreen%s #greenis restricted'%(weapon.replace('weapon_', '')))
					es.sexec(self.userid, 'lastinv')

	def check_respawn(self):
		if self.steamid == 'BOT':
			if temp_zombies > 0:
				global temp_zombies
				temp_zombies -= 1
				es.server.queuecmd('est_spawn %s'%self.userid)

	def set_attributes(self, model):
		if self.steamid == 'BOT':
			if random.randint(1, 100) > float(sv('zh_boss_chance')) or wins < int(sv('zh_rounds_to_win')):
				if model:
					playerlib.getPlayer(self.userid).set('model', random.choice(str(sv('zh_zombie_models')).split(',')))
				playerlib.getPlayer(self.userid).set('health', random_value(int(sv('zh_zombie_health_min')), int(sv('zh_zombie_health_max')) + (wins * float(sv('zh_zombie_health_level_bonus_multiplier')))))
				playerlib.getPlayer(self.userid).set('speed', random_value(float(sv('zh_zombie_speed_min')), float(sv('zh_zombie_speed_max'))) + (wins * float(sv('zh_zombie_speed_level_bonus_multiplier'))))
				playerlib.getPlayer(self.userid).set('armor', random_value(int(sv('zh_zombie_armor_min')), int(sv('zh_zombie_armor_max'))) + (wins * float(sv('zh_zombie_armor_level_bonus_multiplier'))))
				es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(float(sv('zh_zombie_gravity_min')), float(sv('zh_zombie_gravity_max'))) - (wins * float(sv('zh_zombie_gravity_level_multiplier')))))
			else:
				playerlib.getPlayer(self.userid).set('model', str(sv('zh_boss_model')))
				playerlib.getPlayer(self.userid).set('health', random_value(float(sv('zh_boss_health_min')), int(sv('zh_boss_health_max'))))
				playerlib.getPlayer(self.userid).set('speed', random_value(float(sv('zh_boss_speed_min')), float(sv('zh_boss_speed_max'))))
				playerlib.getPlayer(self.userid).set('armor', random_value(int(sv('zh_boss_armor_min')), int(sv('zh_boss_armor_max'))))
				es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(float(sv('zh_boss_gravity_min')), float(sv('zh_boss_gravity_max')))))
			playerlib.getPlayer(self.userid).set('cash', 0)
		else:
			if int(sv('zh_start_cash')):
				playerlib.getPlayer(self.userid).set('cash', int(sv('zh_start_cash')))

	def hud(self):
		humans = 0
		zombies = 0
		for userid in playerlib.getUseridList('#human,#alive'):
			humans += 1
		for userid in playerlib.getUseridList('#bot,#alive'):
			zombies += 1
		usermsg.hudhint(self.userid, '!!! Zombie Hell !!!\nHumans: %s\nZombies: %s\nDifficulty: %s\nReserve: %s'%(humans, zombies, messages[wins], temp_zombies))

	def play_sound(self):
		if self.steamid == 'BOT':
			sounds = []
			for a in range(1, 10):
				if a < 5:
					sounds.append('npc/zombie/moan_loop' + str(a))
				if a < 4:
					sounds.append('npc/zombie/zombie_die' + str(a))
					sounds.append('npc/zombie/zombie_alert' + str(a))
				if sounds < 7:
					sounds.append('npc/zombie/zombie_pain' + str(a))
				sounds.append('npc/zombie/zombie_voice_idle' + str(a))
			sound = random.choice(sounds)
			es.emitsound('player', self.userid, sound + '.wav', 0.75, 0.4)
			gamethread.delayed(3, es.stopsound, (self.userid, sound + '.wav'))

	def check_team(self):
		if es.exists('userid', self.userid):
			if self.steamid == 'BOT':
				if not playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 2'%self.userid)
			else:
				if playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 3'%self.userid)
					es.tell(self.userid, '#multi', '#lightgreen[Zombie Hell]: #defaultHumans can only be on the #lightgreenTerrorists')

	def knockback(self, attacker, damage):
		if self.steamid == 'BOT':
			if int(sv('zh_enable_knockback')):
				knockback = random_value(float(sv('zh_zombie_knockback_min')) if wins < int(sv('zh_rounds_to_win')) else float(sv('zh_boss_knockback_min')), float(sv('zh_zombie_knockback_max')) if wins < int(sv('zh_rounds_to_win')) else float(sv('zh_boss_knockback_max')))
				knockback *= int(damage)
				knockback -= float(sv('zh_zombie_knockback_level_multiplier_minus')) * wins if wins < int(sv('zh_rounds_to_win')) else 0
				if int(attacker) and not int(self.userid) == int(attacker):
					x, y, z = playerlib.getPlayer(attacker).get('viewvector')
					es.setplayerprop(self.userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '%s,%s,%s'%(x * knockback, y * knockback, z * knockback))

	def overlay(self, reason):
		if not self.steamid == 'BOT':
			overlays = {1: str(sv('zh_round_start_overlay')), 2: str(sv('zh_round_end_overlay_win')), 3: str(sv('zh_round_end_overlay_lose'))}
			if not overlays[reason] == '0':
				es.cexec(self.userid, 'r_screenoverlay %s'%overlays[reason])
				if not str(sv('zh_overlay_sound')) == '0':
					es.cexec(self.userid, 'play %s'%str(sv('zh_overlay_sound')))

	def stop_spawn(self):
		if zspawn.has_key(str(self.userid)):
			global zspawn
			del zspawn[str(self.userid)]

	def start_spawn(self):
		global zspawn
		zspawn[str(self.userid)] = 1

	def start_spawn_protection(self):
		if float(sv('zh_zombie_spawn_protection_time')):
			if self.steamid == 'BOT':
				playerlib.getPlayer(self.userid).set('health', 9999)
				gamethread.delayedname(float(sv('zh_zombie_spawn_protection_time')), 'spawn_protection_%s'%self.userid, self.stop_spawn_protection)

	def stop_spawn_protection(self):
		if self.steamid == 'BOT':
			if float(sv('zh_zombie_spawn_protection_time')):
				gamethread.cancelDelayed('spawn_protection_%s'%self.userid)
				if es.exists('userid', self.userid):
					if not playerlib.getPlayer(self.userid).get('isdead'):
						self.set_attributes(0)

	def napalm(self):
		if self.steamid == 'BOT':
			if int(sv('zh_napalm')):
				self.burn(float(sv('zh_napalm_time')))

	def burn(self, time):
		es.server.queuecmd('es_fire %s !self ignite'%self.userid)
		gamethread.delayed(float(sv('zh_napalm_time')), self.extinguish)
	
	def extinguish(self): # WE ALL WUB YOU, FREDDUKES :D
		napalmlist = es.createentitylist('entityflame')
		handle = es.getplayerhandle(self.userid)
		for flame_entity in napalmlist:
			string = es.getindexprop(flame_entity, 'CEntityFlame.m_hEntAttached')
			if string == handle:
				es.setindexprop(flame_entity, 'CEntityFlame.m_flLifetime', 0)
				break

	def heal(self):
		if float(sv('zh_health_kill_bonus')):
			if not self.steamid == 'BOT':
				playerlib.getPlayer(self.userid).set('health', playerlib.getPlayer(self.userid).get('health') + int(sv('zh_health_kill_bonus')))

### Functions ###

def add_downloads():
	if os.path.isfile(es.getAddonPath('zombiehell') + '/downloads.cfg'):
		for a in return_downloads():
			#if os.path.isfile(es.getAddonPath('zombiehell').replace('addons/eventscripts/zombiehell', a)):
			es.stringtable('downloadables', a)
			#else:
				#es.dbgmsg(0, 'Zombie Hell Error: No such file %s'%a)

def zh_fog_start():
	if int(sv('zh_fog')):
		userid = es.getuserid()
		r, g, b = str(sv('zh_fog_rgb')).split(',')
		r2, g2, b2 = str(sv('zh_fog_rgb2')).split(',')
		if userid and not fogged:
			global fogged
			fogged = 1
			es.server.queuecmd('es_xgive %s env_fog_controller'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogdir %s %s %s\"'%(userid, 0, 0, 0))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogstart %s\"'%(userid, int(sv('zh_fog_start'))))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogend %s\"'%(userid, int(sv('zh_fog_end'))))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogblend 1"'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor %s %s %s\"'%(userid, r, g, b))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 %s %s %s\"'%(userid, r2, g2, b2))
			es.server.queuecmd('es_xfire %s env_fog_controller turnon'%userid)
	if not str(sv('zh_skybox')) == '0':
		es.server.queuecmd('sv_skyname %s'%str(sv('zh_skybox')))

def knife_bot():
	es.server.queuecmd('bot_knives_only 1')
	es.server.queuecmd('bot_join_after_player 0')
	es.server.queuecmd('bot_join_team t')
	es.set('mp_limitteams', 0)
	es.set('mp_autoteambalance', 0)

def add_bots():
	bots = int(sv('zh_bots')) - len(playerlib.getPlayerList('#bot'))
	while bots > 0:
		es.server.queuecmd('bot_add_t')
		bots -= 1
	while bots < 0:
		es.server.queuecmd('bot_kick %s'%es.getplayername(random.choice(playerlib.getUseridList('#bot'))))
		bots += 1
	change_teams()

def kick_bots():
	es.server.queuecmd('bot_kick')

def change_teams():
	for userid in es.getUseridList():
		Player(userid).check_team()

def do_zspawn():
	userid = es.getcmduserid()
	if zspawn.has_key(str(userid)):
		es.server.queuecmd('est_spawn %s'%userid)
	else:
		es.tell(userid, '#multi', '#lightgreen[ZombieHell]: #defaultYou can only spawn as soon as you join!')

### Returns ###

def random_value(low, high):
	return random.randint(int(low * 1000), int(high * 1000)) / 1000.0

def return_downloads():
	if os.path.isfile(es.getAddonPath('zombiehell') + '/downloads.cfg'):
		a = open(es.getAddonPath('zombiehell') + '/downloads.cfg', 'r')
		b = a.readlines()
		a.close()
		return map(lambda x: x.replace('\n', '').replace('\\', '/').replace('downloadable', ''), filter(lambda x: not x.startswith('//') and not x == '\n', b))
	else:
		es.dbgmsg(0, 'ERROR: No downloads.cfg found for Zombie Hell!')

### Loops ###

def update_hud():
	for userid in es.getUseridList():
		Player(userid).hud()
	gamethread.delayedname(float(sv('zh_hud_update_time')), 'update_hud', update_hud)

def ambiance_loop():
	if not str(sv('zh_ambiance_delay')) == '0':
		gamethread.delayedname(float(sv('zh_ambiance_delay')), 'ambiance_loop', ambiance_loop)
		for userid in es.getUseridList():
			es.stopsound(userid, str(sv('zh_ambiance')))
			#es.emitsound('player', userid, str(sv('zh_ambiance')), 0.75, 0.1)
			#es.cexec(userid, 'play %s'%str(sv('zh_ambiance')))
			es.playsound(userid, str(sv('zh_ambiance')), 0.99)
	else:
		es.dbgmsg(0, 'ZombieHell Fatal Error: Please change zh_ambiance_delay from 0 to a value greater!')

def heal_loop():
	if float(sv('zh_zombie_regen_delay')):
		gamethread.delayedname(float(sv('zh_zombie_regen_delay')), 'heal_loop', heal_loop)
		for player in playerlib.getPlayerList('#bot,#alive'):
			if player.get('health') < int(sv('zh_zombie_regen_max_health')):
				player.set('health', (wins * float(sv('zh_zombie_level_regen_multiplier'))) + random_value(float(sv('zh_zombie_regen_min')), float(sv('zh_zombie_regen_max'))) + player.get('health'))

def beacon_loop():
	if int(sv('zh_beacon_last_zombie')):
		gamethread.delayedname(1, 'beacon_loop', beacon_loop)
		if len(playerlib.getPlayerList('#bot,#alive')) == 1:
			x, y, z = es.getplayerlocation(playerlib.getUseridList('#bot,#alive')[0])
			es.emitsound('player', playerlib.getUseridList('#bot,#alive')[0], 'buttons/blip1.wav', 1, 0.8)
			es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 20 400 0.2 20 10 0 255 0 0 255 30'%(x, y, z))
			es.server.queuecmd('est_effect 10 #a 0.1 "sprites/lgtning.vmt" %s %s %s 20 400 0.3 15 10 0 255 150 150 255 30'%(x, y, z))

### Filters ###

def zh_buy_filter(userid, args):
	if args[0].lower() == 'buy':
		if args[1].lower() in str(sv('zh_restricted_weapons')):
			es.tell(userid, '#multi', '#lightgreen[Zombie Hell]: #defaultSorry, the #lightgreen%s#default is restricted'%args[1])
			return False
		if args[1].lower() == 'm249':
			if int(sv('zh_machine_gun_ammo')):
				gamethread.delayed(0, playerlib.getPlayer(userid).set, ('ammo', [1, int(sv('zh_machine_gun_ammo'))]))
	return True

### Call Functions ###
update_hud()
es.addons.registerClientCommandFilter(zh_buy_filter) 
heal_loop()
beacon_loop()



